<%@ page import="java.util.List,
                 java.util.ArrayList,
                 java.util.Iterator,
                 org.codehaus.aspectwerkz.SystemLoader,
                 org.codehaus.aspectwerkz.definition.*,
                 com.bea.tree.*"%><%@ taglib uri='WEB-INF/console_extension_taglib.tld' prefix='wl' %><%!

public void visitClassLoader(TreeNode treeNode, ClassLoader classLoader) {
// add sysdefs
List defs = SystemDefinitionContainer.getSystemDefinitions(classLoader);
for (Iterator it = defs.iterator(); it.hasNext();) {
	SystemDefinition sd = (SystemDefinition)it.next();
	treeNode.addChild(sd.getUuid(), "NodeSubmitForm", "tree_images/folderopen.gif","tree_images/folder.gif");
}
// handle childs(TreeNode)
Set cls = SystemDefinitionContainer.getAllRegisteredClassLoaders();
for (Iterator it = cls.iterator(); it.hasNext();) {
	ClassLoader cl = (ClassLoader)it.next();
	if (classLoader.equals(cl.getParent())) {
		String nickName = null;
		if (cl instanceof  weblogic.utils.classloaders.GenericClassLoader) {
			weblogic.utils.classloaders.Annotation nickNameAnnotation = ((weblogic.utils.classloaders.GenericClassLoader)cl).getAnnotation();
			nickName = nickNameAnnotation.getAnnotationString();//getApplicationName() + " / " + nickNameAnnotation.getModuleName();
		}
		// try to handle weblogic.servlet.jsp.JspClassLoader (which is package private..)
		try {
			Class clc = cl.getClass();
			java.lang.reflect.Field f = clc.getDeclaredField("cname");
			f.setAccessible(true);
			nickName = f.get(cl).toString();
		 } catch (NoSuchFieldException nfe) {
		 	;//not a JspClassLoader
		 } catch (Exception e) {
			nickName = null;
		}
		
		if (nickName == null || nickName.length() == 0) {
			nickName = cl.toString();
		}
		TreeNode child = treeNode.addChild(nickName, "NodeSubmitForm", "tree_images/base.gif", "tree_images/base.gif");
		visitClassLoader(child, cl);
	}
}
}
%><%
response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
response.setHeader("Pragma","no-cache"); //HTTP 1.0
response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
%>
<html>
<head>
	<wl:stylesheet/>
	
	<%-- The styles for the tree go are defined here. Make sure you include this stylesheet where ever you are displaying the tree --%>
	<link href="tree.css" type="text/css" rel="stylesheet"/>
	<script language="JavaScript" src="treeScript.js" type="text/javascript"></script>

</head>
<body>
<div class='content'>
	<h2>AOP definitions</h2>
	<hr>
	<wl:dialog>
		<wl:tab name='t1' label='System Aspects'>
		<br/>
<%
//TODO extract logic to support any CL view
List defs = SystemDefinitionContainer.getSystemDefinitions(ClassLoader.getSystemClassLoader());
for (Iterator sysDefs = defs.iterator(); sysDefs.hasNext();) {
	SystemDefinition sysDef = (SystemDefinition)sysDefs.next();
	%>
	<table border='1' cellpadding='4' cellspacing='0' BORDERCOLOR='#608c8c' width="100%">
		<tr><td colspan=2 bgcolor='#b8cece' width="100%"><span class='column-header'><%= sysDef.getUuid() %></span></td></tr>
		<tr><td width=10%></td><td>
		
		<!-- PREPARE -->
		<!-- HIDDEN FOR DEMO
		<table border='1' cellpadding='4' cellspacing='0' BORDERCOLOR='#608c8c' width="100%">
			<tr><td bgcolor='#b8cece' width="100%"><span class='column-header'>Prepare</span></td></tr>
		<%
		for (Iterator prepares = sysDef.getPreparePackages().iterator(); prepares.hasNext();) {
			out.print("<tr><td><small>" + prepares.next() + "</small></td></tr>");
		}
		%>
		</table>
		-->
		<br/>
		
		<!-- EACH ASPECTS -->
		<%
		for (Iterator aspectDefs = sysDef.getAspectDefinitions().iterator(); aspectDefs.hasNext();) {
			AspectDefinition aspectDef = (AspectDefinition)aspectDefs.next();
			if (aspectDef.getName().startsWith("___AW_")) {
				continue;
			}
			String _aspectLabel = aspectDef.getName();
			if (!aspectDef.getName().equals(aspectDef.getClassName())) {
				_aspectLabel = _aspectLabel + " :" + aspectDef.getClassName();
			}
			%>
			<table border='1' cellpadding='4' cellspacing='0' BORDERCOLOR='#608c8c' width="100%">
				<tr><td bgcolor='#b8cece' width="100%"><span class='column-header'><%= _aspectLabel %></span></td></tr>
				<%
				for (Iterator arounds = aspectDef.getAroundAdvices().iterator(); arounds.hasNext();) {
				    AdviceDefinition around = (AdviceDefinition)arounds.next();
				    //TODO support advice name
				    out.print("<tr><td>" + around.getName());
				    out.print("<br/><small>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
				    out.print(around.getExpressionInfo().getExpressionAsString());
				    out.print("</small></td></tr>");
				}
				%>
			</table>
			<br/>
		<%
		}
		%>
		
		
		</td></tr><!-- system table -->
	</table>
	<br/>
	<%
}//system loop
%>
		</wl:tab>
		
		<wl:tab name='t2' label='Hierarchical view'>
<%		
TreeNode root = new TreeNode("System");
root.setIconSrcOpen("tree_images/base.gif");
root.setIconSrcClosed("tree_images/base.gif");

visitClassLoader(root, ClassLoader.getSystemClassLoader());

TreeStateManager treeStateManager = TreeStateManager.getInstance(session, "System");
treeStateManager.processState(request);
Tree clTree = new Tree("System", root, true);   
out.print(clTree.renderTree(request));




%>		
		
		
		</wl:tab>

		
	</wl:dialog>
</div>
</body>
</html>

