@rem *************************************************************************
@rem This script is used to uninstall a WebLogic Server service for the
@rem domain in the current working directory.  This script simply sets the 
@rem DOMAIN_NAME and SERVER_NAME variable and calls the uninstallSvc.cmd
@rem script under %WL_HOME%\server\bin.
@rem
@rem To create your own domain script, all you need to set is DOMAIN_NAME
@rem and SERVER_NAME, then call %WL_HOME%\server\bin\uninstallSvc.cmd
@rem
@rem For additional information, refer to the WebLogic Server Administration 
@rem Console Online Help(@DOCSWEBROOT/ConsoleHelp/startstop.html)
@rem *************************************************************************

@echo off
SETLOCAL

set WL_HOME=@WL_HOME
for %%i in ("%WL_HOME%") do set WL_HOME=%%~fsi
set DOMAIN_NAME=@DOMAIN_NAME
set SERVER_NAME=@SERVER_NAME

REM Let's remove the all the services that might actually be "installed"
echo Removing services for domain: %DOMAIN_NAME%
%WL_HOME%\server\bin\beasvc -remove -svcname:"beasvc_%DOMAIN_NAME%_debugger"      > nul
%WL_HOME%\server\bin\beasvc -remove -svcname:"beasvc_%DOMAIN_NAME%_pointbase"     > nul
%WL_HOME%\server\bin\beasvc -remove -svcname:"beasvc_%DOMAIN_NAME%_%SERVER_NAME%" > nul
echo Completed.

ENDLOCAL
